SystemOrganization addCategory: #GODBasesTests!

TestCase subclass: #GDBDataTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODBasesTests'!

!GDBDataTest methodsFor: 'helper' stamp: 'lacm 11/5/2014 15:51'!
myMagmaCollection
	^ GDBConnection database.! !

!GDBDataTest methodsFor: 'initialize-release' stamp: 'TD 11/8/2014 19:24'!
setUp	
	GDBController uniqueInstance.
	Transcript show: 'Starting Test'; cr.! !

!GDBDataTest methodsFor: 'initialize-release' stamp: 'TD 11/8/2014 19:32'!
tearDown
	"comment stating purpose of message"
	Transcript show: 'Finishing Test'; cr.
	GDBController release.

	
	! !

!GDBDataTest methodsFor: 'fail' stamp: 'lacm 11/10/2014 16:15'!
testAddANoGodData
	|aNotGODData|
	
		
	aNotGODData :=	'Just a string'.
	
	self should:[GDBController add: aNotGODData] raise: GDBDataMustBeAnGODData .
	"GDBController release."! !

!GDBDataTest methodsFor: 'tests' stamp: 'lacm 11/10/2014 16:22'!
testAddGODDataIsSaved
	|retrievedLastGODData myGODData|
	
		
	myGODData:=	GODData new author: 'author A'; title: 'title A'; yourself.
	
	GDBController add: myGODData.	
	GDBController release.
	
	self should:[self myMagmaCollection size = 1].
	retrievedLastGODData:= self myMagmaCollection detectMax:[:each | each id].
	self should:[retrievedLastGODData id > 0]. ! !

!GDBDataTest methodsFor: 'fail' stamp: 'lacm 11/10/2014 16:22'!
testAddGODDataWithoutAuthor
	|myGODData|
		
	myGODData:=	GODData new title: 'title A'; yourself.
	
	self should:[GDBController add: myGODData] raise: GODDataAuthorMustContainsSomeInformation .! !

!GDBDataTest methodsFor: 'fail' stamp: 'TD 11/8/2014 21:43'!
testAddGODDataWithoutTitle
	|aGODData|
	aGODData :=	GODData new author: 'autor A'; yourself.
	self should:[GDBController add: aGODData] raise: GODDataTitleMustContainsSomeInformation .! !

!GDBDataTest methodsFor: 'tests' stamp: 'TD 11/9/2014 17:52'!
testGetAll
	| a b c collection|
	a := GODData new author: 'author A'; title: 'title A'; yourself.
	b := GODData new author: 'author A'; title: 'title B'; yourself.
	c := GODData new author: 'author B'; title: 'title A'; yourself.

	GDBController add: a; add: b; add: c.
	collection :=  GDBController getAll.
	self should: [collection size = 3].
! !

!GDBDataTest methodsFor: 'tests' stamp: 'lacm 11/10/2014 16:18'!
testRemoveGODDataIsSaved
	|removedGODData|
       removedGODData:= GODData new author: 'author B';
										  title: 'title B' ;
										  yourself.		
	GDBController add: removedGODData.
	
	self should: [self myMagmaCollection size = 1].
	
	GDBController remove: removedGODData.
	
	GDBController release.
	
	self should:[self myMagmaCollection size = 0].! !

!GDBDataTest methodsFor: 'tests' stamp: 'lacm 11/10/2014 16:19'!
testRepositoryEmptyDatabase
	
	self should: [self myMagmaCollection size = 0].
! !

!GDBDataTest methodsFor: 'tests' stamp: 'TD 11/9/2014 17:56'!
testSearchFor
	| a b c collection aBlock|
	a := GODData new author: 'author A'; title: 'title A'; yourself.
	b := GODData new author: 'author A'; title: 'title B'; yourself.
	c := GODData new author: 'author B'; title: 'title A'; yourself.

	GDBController add: a; add: b; add: c.
	aBlock := [:obj | obj author = 'author A'].
	collection :=  GDBController searchFor: aBlock.
	self should: [collection size = 2].
! !
